//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DarkSlateGray
#property indicator_color2  DarkSlateGray
#property indicator_color3  DeepPink
#property indicator_color4  LimeGreen
#property indicator_width1  1 
#property indicator_width2  1
#property indicator_width3  2   
#property indicator_width4  2        

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    NonLagMaPeriod  = 14;
extern int    MaShift         = 0;
extern string _note1          = "0=close,1=open,2=high,3=low";
extern string _cont           = "4=H+L/2,5=H+L+C/3,6=H+L+C+C/4";
extern int    UpperPrice      = 0;
extern int    LowerPrice      = 0;
extern double Deviation       = 0.20;
extern bool   ShowArrows      = true;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsOnHighLow = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
  

//
//
//
//
//

double upEnv[];
double dnEnv[];
double upArr[];
double dnArr[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    IndicatorBuffers(5); 
    SetIndexBuffer(0,upEnv);   SetIndexShift(0,MaShift);
    SetIndexBuffer(1,dnEnv);   SetIndexShift(1,MaShift);
    SetIndexBuffer(2,dnArr);
    SetIndexBuffer(3,upArr);
    SetIndexBuffer(4,trend);
    
    if (ShowArrows)
    {
      SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
      SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
    }
    else
    {
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
    }
    
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      SetIndexShift(0,MaShift * timeFrame/Period());  
      SetIndexShift(1,MaShift * timeFrame/Period());   
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"   nonlag envelope");
   return(0);
}

//+------------------------------------------------------------------
//|                             
//+------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { upEnv[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for (i = limit; i >= 0; i--)
     {
      upEnv[i] = (1+Deviation/100)*iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,UpperPrice,i),NonLagMaPeriod,i,0);
      dnEnv[i] = (1-Deviation/100)*iNonLagMa(iMA(NULL,0,1,0,MODE_SMA,LowerPrice,i),NonLagMaPeriod,i,1);
      dnArr[i] = EMPTY_VALUE;
      upArr[i] = EMPTY_VALUE;
         if (Close[i]<dnEnv[i]) upArr[i] = dnEnv[i] - iATR(NULL,0,20,i)/2;
         if (Close[i]>upEnv[i]) dnArr[i] = upEnv[i] + iATR(NULL,0,20,i)/2;

          //
          //
          //
          //
          //
      
          trend[i] = 0;                     
            if (alertsOnHighLow)       
            {
               if (High[i] > upEnv[i])  trend[i] = -1;
               if (Low[i]  < dnEnv[i])  trend[i] =  1;
            }
            else
            {
               if (Close[i] > upEnv[i]) trend[i] = -1;
               if (Close[i] < dnEnv[i]) trend[i] =  1;
            }
      }
      if (!calculateValue) manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
  
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NonLagMaPeriod,MaShift,"","",UpperPrice,LowerPrice,Deviation,4,y);
            upEnv[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NonLagMaPeriod,MaShift,"","",UpperPrice,LowerPrice,Deviation,0,y);
            dnEnv[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NonLagMaPeriod,MaShift,"","",UpperPrice,LowerPrice,Deviation,1,y);
            dnArr[i] = EMPTY_VALUE;
            upArr[i] = EMPTY_VALUE;
               if (Close[i]<dnEnv[i]) upArr[i] = dnEnv[i] - iATR(NULL,0,20,i)/2;
               if (Close[i]>upEnv[i]) dnArr[i] = upEnv[i] + iATR(NULL,0,20,i)/2;
      }
manageAlerts();
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

double  nlmvalues[2][3];
double  nlmprices[ ][2];
double  nlmalphas[ ][2];

//
//
//
//
//

double iNonLagMa(double price, double length, int r, int instanceNo=0)
{
   r = Bars-r-1;
   if (ArrayRange(nlmprices,0) != Bars)         ArrayResize(nlmprices,Bars);
   if (ArrayRange(nlmvalues,0) <  instanceNo+1) ArrayResize(nlmvalues,instanceNo+1);
                               nlmprices[r][instanceNo]=price;
   if (length<3 || r<3) return(nlmprices[r][instanceNo]);
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_length] != length  || ArraySize(nlmalphas)==0)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlmvalues[instanceNo][_length] = length;
         nlmvalues[instanceNo][_len   ] = length*4 + Phase;  
         nlmvalues[instanceNo][_weight] = 0;

         if (ArrayRange(nlmalphas,0) < nlmvalues[instanceNo][_len]) ArrayResize(nlmalphas,nlmvalues[instanceNo][_len]);
         for (int k=0; k<nlmvalues[instanceNo][_len]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlmalphas[k][instanceNo]        = g * beta;
            nlmvalues[instanceNo][_weight] += nlmalphas[k][instanceNo];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlmvalues[instanceNo][_weight]>0)
   {
      double sum = 0;
           for (k=0; k < nlmvalues[instanceNo][_len]; k++) sum += nlmalphas[k][instanceNo]*nlmprices[r-k][instanceNo];
           return( sum / nlmvalues[instanceNo][_weight]);
   }
   else return(0);           
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," "+timeFrameToString(timeFrame)+" nonlag bands price penetrated ",doWhat," band");
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"nonlag envelopes "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}